/////////////////////////////////////////////////////////
// DDS-IC̐
////////////////////////////////////////////////////////
#define G__EXTERN__ extern

#include "mc400.h"
#include "lcd.h"

//0`350x܂ł̃TCf[^ CfbNX0..35
volatile int sin_dt[36]=
{
	9829,  10967,  12070,   13106,     14041,    14849,    15504,     15987,    16282,
	16382,  16282,  15987,   15504,     14849,    14041,    13106,     12070,    10967,
	9829,   8691,    7588,   6553,       5617,    4809,      4154,      3671,     3376,
	3276,   3376,    3671,   4154,       4809,    5617,      6553,      7588,     8691
};

///////////////////////////////////
// 10usec
void wait_10us(int usec)
{
usec = (int)(36*usec);
//	usec = (int)(1000*usec);
	while(usec)	{
		usec--;
	}
};


////////////////////////////////////////////////
//NbNo
//ʏHiɕۂ
void clock_out(void)
{
	_LATB15=0;
	wait_10us(1);
	_LATB15=1;
	wait_10us(1);
};

/////////////////////////////
//f[^rbgóiNbNtj
void bit_out(u32 dt)
{
  if (dt){
    _LATB14=1;
  }else{
    _LATB14=0;
  }  

  clock_out();
}

////////////////////////////////
// byte o
void byte_out(u08 b)
{
  int i;
  
  for (i=7; i>=0; i--)     
	  bit_out((1<<i) & b);
}

////////////////////////////////
//I/O UPDATE
void io_update(void)
{
	_LATB13=1;
	wait_10us(1);
	_LATB13=0;
}	
	
////////////////////////////////
//CFR1Zbg
//
void cfr1_set(void)
{
	int i;
	u32 swk;
	
	swk=1;
	
  _LATB3=0;        //CS low
	wait_10us(1);
  
  byte_out(0x00);           //CFR1
  	      
//  for (i=31; i>=0; i--)     //CFR1
//    bit_out((swk<<i) & 0x02000000);  //OSK Enable=1
  for (i=31; i>=0; i--)     //CFR1
    bit_out((swk<<i) & 0x00000000);  //OSK Enable=0

  _LATB3=1;        //CS Hi
  
  io_update();     //IO UPDATE
}

//////////////////////////////////
//AMϒ@400Hz
void am_mod(void)
{
	int i, j, wk;
	u16 swk;
	u32 dt;

  j=0;
  
  LCDputs_xy(0, 1, "AM");
  
	while(SW1){              //SW1܂AMϒ𑱂
		for (i=0; i<23; i++)
		  wk=i+1;
		  		
	  dt=(u32)sin_dt[j];
	  j+=1;
	  if (j>35){
	    j=0;
	  };

		swk=1;
		
	  _LATB3=0;        //CS low
	  
	  for (i=7; i>=0; i--){     //ASF
		  if ((1<<i) & 2)
			  _LATB14=1;
		  else
 			  _LATB14=0;
	    	_LATB15=0;
			_LATB15=1;
		};
	  	      
	  for (i=15; i>=0; i--){     //ASF
	    if ((swk<<i) & dt)
	      _LATB14=1;
	    else
	      _LATB14=0;
	    	_LATB15=0;
			_LATB15=1;
		};

	
	  _LATB3=1;        //CS Hi
	  
		_LATB13=1;
		_LATB13=0;
	  
	}
 
  ms_wait(200);    //`^OLZ 

  while(0==SW1){};   //̂҂
	
	rit_view();
 	fhz_view();       //g\XV
};

//////////////////////////////////
//ASFZbg Av
void dds_asf_set(int level)
{
	int i;
	u16 swk;
	u32 dt;
	double wk;
	
	wk=((double)0x3FFF) * ((double)level/100.0); //3FFF=16383
  dt=(u32)wk;
  
	swk=1;
	
  _LATB3=0;        //CS low
	wait_10us(1);
  
  byte_out(0x02);           //ASF
  	      
  for (i=15; i>=0; i--)     //ASF
    bit_out((swk<<i) & dt);  

  _LATB3=1;        //CS Hi
  
  io_update();     //IO UPDATE
	
}	

////////////////////////////////
// vO(N)WX^ݒ
// hz=1HzP
void dds_fset(long int hz)
{
	double wk;
	u32 ftw0, swk;
  int i;
  
  swk=1;

  if (17==pll_x)
    wk=(double)hz * 12.63225675;  //(2^32)/340MHz
  if (18==pll_x)
    wk=(double)hz * 11.93046471;
  if (19==pll_x)
    wk=(double)hz * 11.30254552;    //380MHz  
  if (20==pll_x)
    wk=(double)hz * 10.73741824;  //(2^32)/400MHz 

  if (0==pll_x)
    wk=(double)hz * 10.73741824;  //400MHz {Ȃ
 
  ftw0=(u32)wk;

  _LATB3=0;        //CS low
	wait_10us(1);
  
  byte_out(0x04);           //FTW0
  	      
  for (i=31; i>=0; i--)     //FTW0
    bit_out((swk<<i) & ftw0);

  _LATB3=1;        //CS Hi
  
  io_update();     //IO UPDATE
}
	
/////////////////////////////////////////
//AD9953
void dds_init(void)
{
	_LATB4=0;
	wait_10us(1000);  //reset
	_LATB4=1;
	wait_10us(1000);
	_LATB4=0;
	wait_10us(1000);
	
  _LATB3=0;        //CS low
	wait_10us(1);
  byte_out(0x01);        //CFR2 AhX
  byte_out(0x18);      //Default
  byte_out(0x00);
  if (17==pll_x)
    byte_out(0b10001111);	    //PLL x17  
  if (18==pll_x)
    byte_out(0b10010111);	    //PLL x18  
  if (19==pll_x)
    byte_out(0b10011111);	    //PLL x19  
  if (20==pll_x)
    byte_out(0b10100111);	    //PLL x20  
    
  if (0==pll_x)
    byte_out(0b00000111);	    //PLLȂ@400MHzŒ

  _LATB3=0;        //CS Hi
  io_update();     //IO UPDATE

  _LATB3=0;        //CS low
	wait_10us(1);
  byte_out(0x00);        //CFR1 AhX
  byte_out(0x02);        //OSK Enable=1
  byte_out(0x00);
  byte_out(0x00);
  byte_out(0x00);
  _LATB3=0;        //CS Hi
  io_update();     //IO UPDATE
  
  dds_asf_set(out_level);
}	

/////////////////////////////////////////
//gZbg
void fhz_set(void)
{

	if (0==SW4){              //M@SW4ĂԂ͑MƂ RIT𖳎MItZbgg
		dds_fset(fhz_pll + fhz_sw_offset);
  }else{                    //M
	  if (1==rit_sw)          //rit on
	  	dds_fset(fhz_pll + rit_offset);
	  else
	    dds_fset(fhz_pll);
	}   

}
