///////////////////////////////////////
//LCD 
///////////////////////////////////////
#define G__EXTERN__ extern

#include "mc400.h"
#include "lcd.h"

///////////////////////////////////
// 10usec
void us10_wait(int usec)
{
	usec = (int)(36*usec);
	while(usec)	{
		usec--;
	}
};

/////////////////////////////////////
// msec
void ms_wait(int msec)
{
	int i;
	for(i=0; i< msec; i++)
		us10_wait(120);
};

//R}ho 4bit
void LCDCmd(u08 command)
{
	LATB = (LATB & 0b1111110000111111) | ((command & 0x0f) <<6);  //RB9..RB6

  _LATB11=1;   //E=1
  us10_wait(4);
  _LATB11=0;   //E=0
  us10_wait(4);
}

//R}ho 8bit
void LCDCmd8(s08 command2)
{
  LCDCmd((command2>>4)&0xf);
  LCDCmd(command2&0xf);
}

//Po
void LCDputch(char data)
{
  _LATB10=1;     //RS=1
  LCDCmd((data>>4)&0xf);
  LCDCmd(data&0xf);
  _LATB10=0;     //RS=0
}

//o
void LCDputs(char *str)
{
	_T4IE = 0;			// {^荞݋֎~@|[gς邽

  while(*str) LCDputch(*str++);
  
	_T4IE = 1;			// {^荞݋
}

//o XY
void LCDputs_xy(int x, int y, char *str)
{
  unsigned char point;

	_T4IE = 0;			// {^荞݋֎~@|[gς邽

  point=0x80+x+0x40*y;  //J[\ړ
  LCDCmd8(point);
  
  while(*str) LCDputch(*str++);
  
	_T4IE = 1;			// {^荞݋
}

//J[\ړ
void LCDgotoxy(int x, int y)
{
  s08 point;

  point=0x80+x+0x40*y;
  LCDCmd8(point);
}

//LCD̏
void LCDinit( void )
{
  ms_wait(200);           
  LCDCmd(0x3);
  ms_wait(50);
  LCDCmd(0x3);    
  ms_wait(10);
  LCDCmd(0x3);    
  ms_wait(10);
  LCDCmd(0x2);     
  ms_wait(10);

  LCDCmd8(0x28);   
  LCDCmd8(0x0e);   //J[\ON=0e OFF=0c
  LCDCmd8(0x06);   
  LCDCmd8(0x01);   
  ms_wait(300);
}

//LCD N[
void LCDclrscr(void)
{
  LCDCmd8(0x01);
  ms_wait(150);
}

