////////////////////////////////////////////////
//RS232C
////////////////////////////////////////////////
#define G__EXTERN__ extern

#include <p24FJ64GA002.h>
#include <stdio.h>

#include "mc400.h"
#include "lcd.h"

////////////////////////////////////
//RS232C
void rs232c_init(void)
{
  //RS232C 115Kbps 8bit NP t[Ȃ
  	RPINR18bits.U1RXR=12;
//  	RPOR0bits.RP1R=3; //PGC1ƋL@fobN͎gȂ
  U1BRG=34;
  U1MODE=0b1000100000001000;
  U1STA =0b0000010000000000;
}

/////////////////////////////////////
//RS232CM`FbN
char rs232c_chk(void)
{
	char cmd;
	
	if (!U1STAbits.URXDA)   //Mf[^Ȃ΃^[
	  return 0;
	  
  if (U1STAbits.OERR || U1STAbits.FERR){  //G[񕜏
    U1STA &= 0xFF0;
    U1MODEbits.UARTEN=0;
    U1MODEbits.UARTEN=1;
    return 0;
  }
  
  cmd=getchar();
  
  return cmd;
}

/////////////////////////////////////
//RS232CM`FbN
char rs232c_getchar(void)
{
	char cmd;
	
	while (!U1STAbits.URXDA);  //Mf[^҂
	
  if (U1STAbits.OERR || U1STAbits.FERR){  //G[񕜏
    U1STA &= 0xFF0;
    U1MODEbits.UARTEN=0;
    U1MODEbits.UARTEN=1;
    return 0;
  }
  
  cmd=getchar();
  
  return cmd;
}

//////////////////////////////////////
//AR}h@OR}h[hɓ
void cmd_a(void)
{
	LCDclrscr();  //LCDN[
	LCDputs_xy(0, 0, "Command Mode");
	
	cmd_mode=1;
}	

//////////////////////////////////////
//BR}h@OR}h[h甲
void cmd_b(void)
{
	int wk;
	
	cmd_mode=0;

	LCDclrscr();  //LCDN[

 	wk=ch_read(ch_no);  //`lǂݏo wk=0 ݒ̏ꍇ init_global()̒lg
  ch_view(wk);     //`l\
  
  out_level_view();  //o̓x
  
  rit_view();    //RIT\
  
 	fhz_set();        //PLLgXV

  LCDputs_xy(0, 0, "R");

 	fhz_view();       //g\XV
	
}	


/////////////////////////////////////
//eR}h@@gZbg
void cmd_f(void)
{
	char cmd;
	int i;
	double f, fac;
 
  f=0.0;
  fac=100000000;
  
	for (i=0; i<9; i++){
	  cmd=rs232c_getchar();
	  if ((char)0==cmd)
	    return;
	  if (cmd<'0' || cmd>'9')
	    return;
	    
	  f=f+(cmd-'0')*fac;
	  fac=fac/10;  
 	}
 	
 	dds_fset(f);
}

//////////////////////////////////////
//LCD\
void cmd_d(void)
{
	int i;
	char cmd;
	
	for (i=0; i<15; i++){
	  cmd=rs232c_getchar();
	  if ((char)13==cmd)
	    return;
	  if ((char)32<=cmd && (char)125>=cmd)
  		LCDputch(cmd);
	}
	
}

//////////////////////////////////////
//LCD@J[\ړ
void cmd_c(void)
{
	int i, x, y;
	char cmd, param[4];
	
  for (i=0; i<4; i++){
	  cmd=rs232c_getchar();
	  if ((char)0==cmd)
	    return;
	  if (cmd<'0' || cmd>'9')
	    return;
	  param[i]=cmd;
	}
	
	x=(param[0]-'0')*10 + (param[1]-'0');
	y=(param[2]-'0')*10 + (param[3]-'0');

  if (x>15 || y>1)
    return;
        
  LCDgotoxy(x,y);
}	

/////////////////////////////////////
//xZbgZbg
void cmd_l(void)
{
	char cmd;
	int i;
	double level, fac;
 
  level=0;
  fac=100;
  
	for (i=0; i<3; i++){
	  cmd=rs232c_getchar();
	  if ((char)0==cmd)
	    return;
	  if (cmd<'0' || cmd>'9')
	    return;
	    
	  level=level+(cmd-'0')*fac;
	  fac=fac/10;  
 	}
 	
 	if (level>=0 && level<=100)
   	dds_asf_set(level);
}

/////////////////////////////////////
//LCDN[
void cmd_e(void)
{
	LCDclrscr();  //LCDN[
}
	

/////////////////////////////////////
//R}hM
void cmd_recv(void)
{
	char cmd;
	
	cmd=rs232c_chk();

	if (0==cmd)
	  return;

	if ('A'==cmd){   //OR}h[hɓ
	  cmd_a();
	  return;
	}
	
	if (0==cmd_mode)  //OR}h[hł͂Ȃ
	  return;
	  
	switch (cmd){
		case 'B':   //OR}h[hI
		  cmd_b();
		  break;
		case 'F':   //gZbg
		  cmd_f();
		  break;
		case 'D':   //LCD\
		  cmd_d();
		  break;
		case 'C':   //LCDJ[\ړ
		  cmd_c();
		  break;
		case 'L':   //xZbg
		  cmd_l();
		  break;
		case 'E':   //LCDN[
		  cmd_e();
		  break;
	}
}

